#==============================================================================#
# class SubClassB: initialization, accessors, methods
#==============================================================================#


#------------------------------------------------------------------------------#
# SubClassB initialization:
#------------------------------------------------------------------------------#

"initialize.SubClassB" <-
#function(.Object, filename=character(), filedir=as.character(getwd()), dirfile=character(0), subA=new("SubClassA"), data = data.frame(), ...) {
function(.Object, subA=new("SubClassA"), data = data.frame(), ...) {
   print("------initialize:SubClassB------")
print(paste("SubClassB:init:class(.Object) = ", class(.Object)))

#   .Object <- callNextMethod(.Object, ...);

#   .Object <- callNextMethod(.Object, filename=filename, filedir=filedir, dirfile=dirfile, subA=subA, data=data, ...);
   .Object <- callNextMethod(.Object, subA=subA, data=data, ...);

   .Object@subA = subA;
   .Object@data = data;
   .Object;
}#initialize.SubClassB

setMethod("initialize", "SubClassB", initialize.SubClassB);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setValidity("SubClassB",
   function(object) {
      print("------setValidity:SubClassB------")
print(paste("SubClassB:val:class(object) = ", class(object)))
      msg <- NULL;

      ## check filename
      strg <- object@filename;
#?      if (!(is(strg, "character") && nchar(strg) > 0)) {
      if (!(is(strg, "character") && length(strg) > 0)) {
         msg <- validMsg(msg, paste(sQuote("filename"), "is missing"));
      }#if
print(paste("SubClassB:val:filename = ",object@filename))

      ## check dirfile
      strg <- object@dirfile;
#      strg <- dirFile(object);
#      if (!(is(strg, "character") && nchar(strg) > 0 && file.exists(strg))) {
      if (!(is(strg, "character") && nchar(strg) > 0)) {
         msg <- validMsg(msg, paste(sQuote("dirfile"), "is missing"));
      }#if
print(paste("BaseClass:val:dirfile = ",object@dirfile))

      if (is.null(msg)) TRUE else msg;
   }
)#setValidity


#------------------------------------------------------------------------------#
# SubClassB accessors:
#------------------------------------------------------------------------------#

setMethod("subNameA", signature(object="SubClassB"),
   function(object) {
      subA <- object@subA;
      return(subA@dirfile);
   }
)#subNameA

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setMethod("myName", signature(object="SubClassB"),
   function(object) {
      subA <- object@subA;
      return(subA@myname);
   }
)#myName

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setMethod("myTitle", signature(object="SubClassB"),
   function(object) {
      subA <- object@subA;
      return(subA@mytitle);
   }
)#myTitle


#------------------------------------------------------------------------------#
# SubClassB methods:
#------------------------------------------------------------------------------#


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
