#==============================================================================#
# class SubSubClassB: initialization, accessors, methods
#==============================================================================#


#------------------------------------------------------------------------------#
# SubSubClassB initialization:
#------------------------------------------------------------------------------#

"initialize.SubSubClassB" <-
#function(.Object, filename=character(), filedir=as.character(getwd()), dirfile=character(0), subA=new("SubClassA"), data = data.frame(), subsubnameB="subsubNameB", ...) {
function(.Object, subsubnameB="subsubNameB", ...) {
   print("------initialize:SubSubClassB------")
print(paste("SubSubClassB:init:class(.Object) = ", class(.Object)))

#   .Object <- callNextMethod(.Object, ...);

   ## set default subsubnameB
   if (subsubnameB == "") {
      subsubnameB <- "subsubB";
   }#if
print(paste("SubSubClassB:init:subsubnameB = ", subsubnameB))

#   .Object <- callNextMethod(.Object, filename=filename, filedir=filedir, dirfile=dirfile, subA=subA, data=data, subsubnameB=subsubnameB, ...);
   .Object <- callNextMethod(.Object, subsubnameB=subsubnameB, ...);

#?????:
#   .Object@filename <- filename;
#   .Object@filedir  <- filedir;
#   .Object@dirfile  <- dirfile;

   .Object@subsubnameB <- subsubnameB;
   .Object;
}#initialize.SubSubClassB

setMethod("initialize", "SubSubClassB", initialize.SubSubClassB);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setValidity("SubSubClassB",
   function(object) {
      print("------setValidity:SubSubClassB------")
print(paste("SubSubClassB:val:class(object) = ", class(object)))
      msg <- NULL;

      ## check subsubnameB
      strg <- object@subsubnameB;
      if (!(is(strg, "character") && nchar(strg) > 0)) {
         msg <- validMsg(msg, paste(sQuote("subsubnameB"), "is missing"));
      }#if
print(paste("SubSubClassB:val:subsubnameB = ",object@subsubnameB))

      if (is.null(msg)) TRUE else msg;
   }
)#setValidity


#------------------------------------------------------------------------------#
# SubSubClassB accessors:
#------------------------------------------------------------------------------#

setMethod("myFrameB", signature(object="SubSubClassB"),
   function(object) object@data
)#myFrameB

setReplaceMethod("myFrameB", signature(object="SubSubClassB", value="data.frame"),
   function(object, value) {
      object@data <- value;
      return(object);
   }
)#myFrameB<-


#------------------------------------------------------------------------------#
# SubSubClassB methods:
#------------------------------------------------------------------------------#


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
