#==============================================================================#
# class SubSubClassA: initialization, accessors, methods
#==============================================================================#


#------------------------------------------------------------------------------#
# SubSubClassA initialization:
#------------------------------------------------------------------------------#

"initialize.SubSubClassA" <-
function(.Object, ...) {
   print("------initialize:SubSubClassA------")
print(paste("SubSubClassA:init:class(.Object) = ", class(.Object)))

#   callNextMethod();
   .Object <- callNextMethod(.Object, ...);
   .Object;
}#initialize.SubSubClassA

setMethod("initialize", "SubSubClassA", initialize.SubSubClassA);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setValidity("SubSubClassA",
   function(object) {
      print("------setValidity:SubSubClassA------")
print(paste("SubSubClassA:val:class(.Object) = ", class(object)))
      msg <- NULL;

      if (is.null(msg)) TRUE else msg;
   }
)#setValidity


#------------------------------------------------------------------------------#
# SubSubClassA accessors:
#------------------------------------------------------------------------------#

setMethod("myFrameA", signature(object="SubSubClassA"),
   function(object) object@data
)#myFrameA

setReplaceMethod("myFrameA", signature(object="SubSubClassA", value="data.frame"),
   function(object, value) {
      object@data <- value;
      return(object);
   }
)#myFrameA<-


#------------------------------------------------------------------------------#
# SubSubClassA methods:
#------------------------------------------------------------------------------#

"methodsubsubB.SubSubClassA" <-
function(object, filename=character(0), filedir=character(0),subsubnameB="") {
   print("------methodsubsubB.SubSubClassA------")

   ## create new class
   print("------create new class SubSubClassB------")
   subsubB <- new("SubSubClassB", filename=filename, filedir=filedir,
                  dirfile=subnameA, subsubnameB=subsubnameB);
}#mymethod.SubSubClassA

setMethod("methodsubsubB", "SubSubClassA", methodsubsubB.SubSubClassA);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

